<!DOCTYPE html>


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Helpers &mdash; Bérou 0.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-3.3.4/css/bootstrap.min.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-3.3.4/css/bootstrap-theme.min.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '0.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="../_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="../_static/bootstrap-3.3.4/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="../_static/bootstrap-sphinx.js"></script>
    <link rel="top" title="Bérou 0.1 documentation" href="../index.html" />
    <link rel="up" title="Development" href="index.html" />
    <link rel="next" title="How to translate my app ?" href="i18n.html" />
    <link rel="prev" title="How to make my app an installable python package?" href="git.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body role="document">

  <div id="navbar" class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="../index.html">
          Bérou</a>
        <span class="navbar-text navbar-version pull-left"><b>0.1</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="../index.html">Site <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="index.html">Development</a></li>
<li class="toctree-l1"><a class="reference internal" href="../deployment/index.html">Deployment</a></li>
<li class="toctree-l1"><a class="reference internal" href="../usage/index.html">Usage</a></li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">Helpers</a><ul>
<li><a class="reference internal" href="#mixins">mixins</a><ul>
<li><a class="reference internal" href="#loginrequiredmixin">LoginRequiredMixin</a></li>
<li><a class="reference internal" href="#ownershiprequiredmixin">OwnershipRequiredMixin</a></li>
<li><a class="reference internal" href="#loginexcludedmixin">LoginExcludedMixin</a></li>
</ul>
</li>
<li><a class="reference internal" href="#templatetags">Templatetags</a><ul>
<li><a class="reference internal" href="#form-helpers">Form helpers</a><ul>
<li><a class="reference internal" href="#load">Load</a></li>
<li><a class="reference internal" href="#add-class">add_class</a></li>
<li><a class="reference internal" href="#add-attribute">add_attribute</a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#includes-templates">Includes (templates)</a></li>
</ul>
</li>
</ul>
</ul>
</li>
              
            
            
              
                
  <li>
    <a href="git.html" title="Previous Chapter: How to make my app an installable python package?"><span class="glyphicon glyphicon-chevron-left visible-sm"></span><span class="hidden-sm hidden-tablet">&laquo; How to make my a...</span>
    </a>
  </li>
  <li>
    <a href="i18n.html" title="Next Chapter: How to translate my app ?"><span class="glyphicon glyphicon-chevron-right visible-sm"></span><span class="hidden-sm hidden-tablet">How to translate... &raquo;</span>
    </a>
  </li>
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="../_sources/development/helpers.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="col-md-12">
      
  <div class="section" id="helpers">
<h1>Helpers<a class="headerlink" href="#helpers" title="Permalink to this headline">¶</a></h1>
<p>Bérou comes with a few helpers to help you develop your Bérou applications.
Keep in mind that you do not need these helpers to write an application,
they are just here to help.</p>
<div class="section" id="mixins">
<h2>mixins<a class="headerlink" href="#mixins" title="Permalink to this headline">¶</a></h2>
<p>Since Bérou is Class-Based Views oriented, Bérou comes with a few mixins that you use in your views.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c"># -*- coding: utf-8 -*-</span>

<span class="kn">from</span> <span class="nn">django.contrib.auth.decorators</span> <span class="kn">import</span> <span class="n">login_required</span>
<span class="kn">from</span> <span class="nn">django.utils.decorators</span> <span class="kn">import</span> <span class="n">method_decorator</span>

<span class="kn">from</span> <span class="nn">django.shortcuts</span> <span class="kn">import</span> <span class="n">redirect</span>


<span class="k">class</span> <span class="nc">OwnershipRequiredMixin</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Changes the queryset to contain only the user&#39;s links&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="nf">get_queryset</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">user</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span><span class="o">.</span><span class="n">all</span><span class="p">()</span>


<span class="k">class</span> <span class="nc">LoginRequiredMixin</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Ensures that user must be authenticated in order to access view.&quot;&quot;&quot;</span>

    <span class="nd">@method_decorator</span><span class="p">(</span><span class="n">login_required</span><span class="p">)</span>
    <span class="k">def</span> <span class="nf">dispatch</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="k">return</span> <span class="nb">super</span><span class="p">(</span><span class="n">LoginRequiredMixin</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="n">dispatch</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>


<span class="k">class</span> <span class="nc">LoginExcludedMixin</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Ensures that user must be authenticated in order to access view.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="nf">dispatch</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="o">.</span><span class="n">is_authenticated</span><span class="p">():</span>
            <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s">&#39;berou:home&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="nb">super</span><span class="p">(</span><span class="n">LoginExcludedMixin</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="n">dispatch</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
</pre></div>
</div>
<p>If you want to use any of these, here is a few examples</p>
<div class="section" id="loginrequiredmixin">
<h3>LoginRequiredMixin<a class="headerlink" href="#loginrequiredmixin" title="Permalink to this headline">¶</a></h3>
<p>This mixin is here to prevent anonymous users to access protected pages
(i.e the user needs to be logged in).
The anonymous user will be redirected to the login page.
If the login is successful, the user will be brought back on the page they were trying to access before.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c"># -*- coding: utf-8 -*-</span>

<span class="kn">from</span> <span class="nn">django.views.generic</span> <span class="kn">import</span> <span class="n">TemplateView</span>

<span class="kn">from</span> <span class="nn">berou.mixins</span> <span class="kn">import</span> <span class="n">LoginRequiredMixin</span>


<span class="k">class</span> <span class="nc">MyView</span><span class="p">(</span><span class="n">LoginRequiredMixin</span><span class="p">,</span> <span class="n">TemplateView</span><span class="p">):</span>
    <span class="n">template_name</span> <span class="o">=</span> <span class="s">&#39;my_app/my_template.html&#39;</span>
</pre></div>
</div>
</div>
<div class="section" id="ownershiprequiredmixin">
<h3>OwnershipRequiredMixin<a class="headerlink" href="#ownershiprequiredmixin" title="Permalink to this headline">¶</a></h3>
<p>This mixin is here to prevent users to list/edit/delete objects that don&#8217;t belong to them.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c"># -*- coding: utf-8 -*-</span>
<span class="kn">from</span> <span class="nn">berou.mixins</span> <span class="kn">import</span> <span class="n">OwnershipRequiredMixin</span>

<span class="kn">from</span> <span class="nn">my_app</span> <span class="kn">import</span> <span class="n">models</span>

<span class="k">class</span> <span class="nc">ListItemView</span><span class="p">(</span><span class="n">LoginRequiredMixin</span><span class="p">,</span> <span class="n">OwnershipRequiredMixin</span><span class="p">,</span> <span class="n">ListView</span><span class="p">):</span>
    <span class="n">model</span> <span class="o">=</span> <span class="n">models</span><span class="o">.</span><span class="n">Item</span>
</pre></div>
</div>
</div>
<div class="section" id="loginexcludedmixin">
<h3>LoginExcludedMixin<a class="headerlink" href="#loginexcludedmixin" title="Permalink to this headline">¶</a></h3>
<p>This mixin does the opposite of <cite>LoginRequiredMixin</cite>.
This page will prevent authenticated users to access a page.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c"># -*- coding: utf-8 -*-</span>
<span class="kn">from</span> <span class="nn">django.views.generic.edit</span> <span class="kn">import</span> <span class="n">CreateView</span>

<span class="kn">from</span> <span class="nn">berou.mixins</span> <span class="kn">import</span> <span class="n">LoginExcludedMixin</span>

<span class="k">class</span> <span class="nc">RegisterUserView</span><span class="p">(</span><span class="n">LoginExcludedMixin</span><span class="p">,</span> <span class="n">CreateView</span><span class="p">):</span>
    <span class="n">template_name</span> <span class="o">=</span> <span class="s">&#39;accounts/register_user.html&#39;</span>
    <span class="c"># other attributes/methods here</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="templatetags">
<h2>Templatetags<a class="headerlink" href="#templatetags" title="Permalink to this headline">¶</a></h2>
<p>In order to use these templatetags, you will need to load them in your templates.
For each set of templatetags, the import will be given.</p>
<div class="section" id="form-helpers">
<h3>Form helpers<a class="headerlink" href="#form-helpers" title="Permalink to this headline">¶</a></h3>
<div class="section" id="load">
<h4>Load<a class="headerlink" href="#load" title="Permalink to this headline">¶</a></h4>
<div class="highlight-python"><div class="highlight"><pre>{% load form_helpers %}
</pre></div>
</div>
</div>
<div class="section" id="add-class">
<h4>add_class<a class="headerlink" href="#add-class" title="Permalink to this headline">¶</a></h4>
<p>This templatetag is a filter to be used on Django form fields. It adds a class, or classes passed in:</p>
<div class="highlight-html"><div class="highlight"><pre>{{ form.my_field|add_class:&quot;class1 class2&quot; }}
</pre></div>
</div>
</div>
<div class="section" id="add-attribute">
<h4>add_attribute<a class="headerlink" href="#add-attribute" title="Permalink to this headline">¶</a></h4>
<p>This templatetag is a filter to be used on Django form fields.
It adds attributes and their values to the generated input tag.
To seperate out the attribute and its value, use the <cite>:</cite> character.</p>
<div class="highlight-html"><div class="highlight"><pre>{{ form.my_field|add_attribute:&quot;data-foo:42&quot; }}
</pre></div>
</div>
<p>The generated &lt;input&gt; tag will contain an extra attribute: data-foo=&#8221;42&#8221;.</p>
<p>This filter can be used in chain in order to add more than one attribute at a time::</p>
<div class="highlight-python"><div class="highlight"><pre>{{ form.my_field|add_attribute:&quot;data-foo:42&quot;|add_attribute:&quot;data-bar:0&quot; }}
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="includes-templates">
<h2>Includes (templates)<a class="headerlink" href="#includes-templates" title="Permalink to this headline">¶</a></h2>
<p>Last, but not least, here is a very helpful template that you use in your template in order to render forms.</p>
<div class="highlight-html"><div class="highlight"><pre><span class="nt">&lt;form</span> <span class="na">method=</span><span class="s">&quot;POST&quot;</span><span class="nt">&gt;</span>
    {% csrf_token %}
    {% include &quot;berou/includes/field.html&quot; with field=form.my_field %}
    <span class="nt">&lt;div</span> <span class="na">class=</span><span class="s">&quot;form-group&quot;</span><span class="nt">&gt;</span>
        <span class="nt">&lt;div</span> <span class="na">class=</span><span class="s">&quot;col-md-offset-2 col-md-10&quot;</span><span class="nt">&gt;</span>
            <span class="nt">&lt;button</span> <span class="na">class=</span><span class="s">&quot;btn btn-primary&quot;</span> <span class="na">type=</span><span class="s">&quot;submit&quot;</span><span class="nt">&gt;</span>{% trans &quot;Register&quot; %}<span class="nt">&lt;/button&gt;</span>
        <span class="nt">&lt;/div&gt;</span>
    <span class="nt">&lt;/div&gt;</span>
<span class="nt">&lt;/form&gt;</span>
</pre></div>
</div>
</div>
</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2015, Francois Ribemont.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.3.1.<br/>
    </p>
  </div>
</footer>
  </body>
</html>